/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
	"time"
)

// checks if the AssetTranslation type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AssetTranslation{}

// AssetTranslation struct for AssetTranslation
type AssetTranslation struct {
	Language string `json:"language"`
	Text *string `json:"text,omitempty"`
	Media *AssetMedia `json:"media,omitempty"`
	Template *AssetTemplateData `json:"template,omitempty"`
	AcceptedBy *string `json:"accepted_by,omitempty"`
	AcceptedAt *time.Time `json:"accepted_at,omitempty"`
	AutoShortened *bool `json:"auto_shortened,omitempty"`
}

// NewAssetTranslation instantiates a new AssetTranslation object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAssetTranslation(language string) *AssetTranslation {
	this := AssetTranslation{}
	this.Language = language
	return &this
}

// NewAssetTranslationWithDefaults instantiates a new AssetTranslation object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAssetTranslationWithDefaults() *AssetTranslation {
	this := AssetTranslation{}
	return &this
}

// GetLanguage returns the Language field value
func (o *AssetTranslation) GetLanguage() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Language
}

// GetLanguageOk returns a tuple with the Language field value
// and a boolean to check if the value has been set.
func (o *AssetTranslation) GetLanguageOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Language, true
}

// SetLanguage sets field value
func (o *AssetTranslation) SetLanguage(v string) {
	o.Language = v
}

// GetText returns the Text field value if set, zero value otherwise.
func (o *AssetTranslation) GetText() string {
	if o == nil || IsNil(o.Text) {
		var ret string
		return ret
	}
	return *o.Text
}

// GetTextOk returns a tuple with the Text field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AssetTranslation) GetTextOk() (*string, bool) {
	if o == nil || IsNil(o.Text) {
		return nil, false
	}
	return o.Text, true
}

// HasText returns a boolean if a field has been set.
func (o *AssetTranslation) HasText() bool {
	if o != nil && !IsNil(o.Text) {
		return true
	}

	return false
}

// SetText gets a reference to the given string and assigns it to the Text field.
func (o *AssetTranslation) SetText(v string) {
	o.Text = &v
}

// GetMedia returns the Media field value if set, zero value otherwise.
func (o *AssetTranslation) GetMedia() AssetMedia {
	if o == nil || IsNil(o.Media) {
		var ret AssetMedia
		return ret
	}
	return *o.Media
}

// GetMediaOk returns a tuple with the Media field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AssetTranslation) GetMediaOk() (*AssetMedia, bool) {
	if o == nil || IsNil(o.Media) {
		return nil, false
	}
	return o.Media, true
}

// HasMedia returns a boolean if a field has been set.
func (o *AssetTranslation) HasMedia() bool {
	if o != nil && !IsNil(o.Media) {
		return true
	}

	return false
}

// SetMedia gets a reference to the given AssetMedia and assigns it to the Media field.
func (o *AssetTranslation) SetMedia(v AssetMedia) {
	o.Media = &v
}

// GetTemplate returns the Template field value if set, zero value otherwise.
func (o *AssetTranslation) GetTemplate() AssetTemplateData {
	if o == nil || IsNil(o.Template) {
		var ret AssetTemplateData
		return ret
	}
	return *o.Template
}

// GetTemplateOk returns a tuple with the Template field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AssetTranslation) GetTemplateOk() (*AssetTemplateData, bool) {
	if o == nil || IsNil(o.Template) {
		return nil, false
	}
	return o.Template, true
}

// HasTemplate returns a boolean if a field has been set.
func (o *AssetTranslation) HasTemplate() bool {
	if o != nil && !IsNil(o.Template) {
		return true
	}

	return false
}

// SetTemplate gets a reference to the given AssetTemplateData and assigns it to the Template field.
func (o *AssetTranslation) SetTemplate(v AssetTemplateData) {
	o.Template = &v
}

// GetAcceptedBy returns the AcceptedBy field value if set, zero value otherwise.
func (o *AssetTranslation) GetAcceptedBy() string {
	if o == nil || IsNil(o.AcceptedBy) {
		var ret string
		return ret
	}
	return *o.AcceptedBy
}

// GetAcceptedByOk returns a tuple with the AcceptedBy field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AssetTranslation) GetAcceptedByOk() (*string, bool) {
	if o == nil || IsNil(o.AcceptedBy) {
		return nil, false
	}
	return o.AcceptedBy, true
}

// HasAcceptedBy returns a boolean if a field has been set.
func (o *AssetTranslation) HasAcceptedBy() bool {
	if o != nil && !IsNil(o.AcceptedBy) {
		return true
	}

	return false
}

// SetAcceptedBy gets a reference to the given string and assigns it to the AcceptedBy field.
func (o *AssetTranslation) SetAcceptedBy(v string) {
	o.AcceptedBy = &v
}

// GetAcceptedAt returns the AcceptedAt field value if set, zero value otherwise.
func (o *AssetTranslation) GetAcceptedAt() time.Time {
	if o == nil || IsNil(o.AcceptedAt) {
		var ret time.Time
		return ret
	}
	return *o.AcceptedAt
}

// GetAcceptedAtOk returns a tuple with the AcceptedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AssetTranslation) GetAcceptedAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.AcceptedAt) {
		return nil, false
	}
	return o.AcceptedAt, true
}

// HasAcceptedAt returns a boolean if a field has been set.
func (o *AssetTranslation) HasAcceptedAt() bool {
	if o != nil && !IsNil(o.AcceptedAt) {
		return true
	}

	return false
}

// SetAcceptedAt gets a reference to the given time.Time and assigns it to the AcceptedAt field.
func (o *AssetTranslation) SetAcceptedAt(v time.Time) {
	o.AcceptedAt = &v
}

// GetAutoShortened returns the AutoShortened field value if set, zero value otherwise.
func (o *AssetTranslation) GetAutoShortened() bool {
	if o == nil || IsNil(o.AutoShortened) {
		var ret bool
		return ret
	}
	return *o.AutoShortened
}

// GetAutoShortenedOk returns a tuple with the AutoShortened field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AssetTranslation) GetAutoShortenedOk() (*bool, bool) {
	if o == nil || IsNil(o.AutoShortened) {
		return nil, false
	}
	return o.AutoShortened, true
}

// HasAutoShortened returns a boolean if a field has been set.
func (o *AssetTranslation) HasAutoShortened() bool {
	if o != nil && !IsNil(o.AutoShortened) {
		return true
	}

	return false
}

// SetAutoShortened gets a reference to the given bool and assigns it to the AutoShortened field.
func (o *AssetTranslation) SetAutoShortened(v bool) {
	o.AutoShortened = &v
}

func (o AssetTranslation) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AssetTranslation) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["language"] = o.Language
	if !IsNil(o.Text) {
		toSerialize["text"] = o.Text
	}
	if !IsNil(o.Media) {
		toSerialize["media"] = o.Media
	}
	if !IsNil(o.Template) {
		toSerialize["template"] = o.Template
	}
	if !IsNil(o.AcceptedBy) {
		toSerialize["accepted_by"] = o.AcceptedBy
	}
	if !IsNil(o.AcceptedAt) {
		toSerialize["accepted_at"] = o.AcceptedAt
	}
	if !IsNil(o.AutoShortened) {
		toSerialize["auto_shortened"] = o.AutoShortened
	}
	return toSerialize, nil
}

type NullableAssetTranslation struct {
	value *AssetTranslation
	isSet bool
}

func (v NullableAssetTranslation) Get() *AssetTranslation {
	return v.value
}

func (v *NullableAssetTranslation) Set(val *AssetTranslation) {
	v.value = val
	v.isSet = true
}

func (v NullableAssetTranslation) IsSet() bool {
	return v.isSet
}

func (v *NullableAssetTranslation) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAssetTranslation(val *AssetTranslation) *NullableAssetTranslation {
	return &NullableAssetTranslation{value: val, isSet: true}
}

func (v NullableAssetTranslation) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAssetTranslation) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


